SystemOrganization addCategory: #PharoKernel!

Object subclass: #PharoKernel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoKernel'!

!PharoKernel methodsFor: 'loading' stamp: 'MarianoMartinezPeck 4/28/2012 12:45'!
downloadPackagesNamed: listOfPackageNames fromRepositoryNamed: aRepositoryName

	ZnConnectionTimeout value: 300 during: [
	listOfPackageNames do: [:packageName |
	  FileStream forceNewFileNamed: (packageName, '.st') do: [:file |
	    file nextPutAll: (ScriptLoader latestSource: packageName location: aRepositoryName)]].
	].

	
	
	! !

!PharoKernel methodsFor: 'loading' stamp: 'MarianoMartinezPeck 4/28/2012 12:21'!
installPackagesNamed: aListOfPackageNames
	(aListOfPackageNames collect: [:each | each , '.st']) 
		do: [:each | FileStream readOnlyFileNamed: each do: [:file | file fileInSilently ].]
	! !

!PharoKernel methodsFor: 'loading' stamp: 'MarianoMartinezPeck 4/28/2012 12:19'!
loadPackagesNamed: aListOfPackageNames fromRepositoryNamed: aRepositoryName
	
	self downloadPackagesNamed: aListOfPackageNames fromRepositoryNamed: aRepositoryName.
	self installPackagesNamed: aListOfPackageNames.
	! !

!PharoKernel methodsFor: 'logging' stamp: 'MarianoMartinezPeck 4/28/2012 12:27'!
log: aString
	FileStream stdout lf; nextPutAll: aString; lf.! !

PharoKernel subclass: #PharoKernelExporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoKernel'!

!PharoKernelExporter class methodsFor: 'instance-creation' stamp: 'MarianoMartinezPeck 4/28/2012 12:11'!
exportCore
	self new exportCore! !

!PharoKernelExporter methodsFor: 'exporting' stamp: 'MarianoMartinezPeck 4/28/2012 20:05'!
exportCore
	| timeToExport |
	self loadFuel.
	timeToExport := [self serializeClassVariablesAndFonts.
	self exportRing.
	self exportGofer.
	self exportPharoCore.] timeToRun.
	self log: 'PharoCore exported in ', timeToExport asString, ' miliseconds'.! !

!PharoKernelExporter methodsFor: 'exporting' stamp: 'MarianoMartinezPeck 4/28/2012 14:11'!
exportGofer

	| packagesNames |
	self log: 'Exporting Gofer packages'.
	packagesNames := self listOfGoferPackages.
	self exportPackagesNamed: packagesNames toFileName: 'gofer.fuel'.
	self log: 'Finished'.! !

!PharoKernelExporter methodsFor: 'private' stamp: 'MarianoMartinezPeck 4/28/2012 12:31'!
exportPackagesNamed: packageNames toFileName: aFileName
	FileStream forceNewFileNamed: aFileName do: [:aStream |
       aStream binary.
       FLPackageStore new storeOn: aStream packages: packageNames.].
! !

!PharoKernelExporter methodsFor: 'exporting' stamp: 'MarianoMartinezPeck 4/28/2012 14:12'!
exportPharoCore

	| packagesNames |
	self log: 'Exporting PharoCore packages'.
	packagesNames := self listOfPharoCorePackages.
	self exportPackagesNamed: packagesNames toFileName: 'pharo-core.fuel'.
	self log: 'Finished'.! !

!PharoKernelExporter methodsFor: 'exporting' stamp: 'MarianoMartinezPeck 4/28/2012 14:07'!
exportRing

	self log: 'Exporting Ring packages'.
	self exportPackagesNamed: #('Ring-Core-Containers' 'Ring-Core-Kernel' ) toFileName: 'ring.fuel'.
	self log: 'Finished'.! !

!PharoKernelExporter methodsFor: 'exporting' stamp: 'MarianoMartinezPeck 4/28/2012 14:11'!
listOfGoferPackages
^ 'Network-Kernel
Network-MIME
Network-UUID
Network-Url
Network-URI
Network-Protocols
PackageInfo
System-FileRegistry
System-Announcements
Monticello
MonticelloConfigurations
Zinc-HTTP
Zinc-Patch-HTTPSocket
Settings-Network
Settings-Monticello
Gofer-Core' lines
! !

!PharoKernelExporter methodsFor: 'exporting' stamp: 'MarianoMartinezPeck 4/28/2012 14:12'!
listOfPharoCorePackages
^ 'Announcements-View
Announcements-Help
Announcements-Tests-Core
Balloon
BalloonTests
Collections-Arithmetic
Collections-Native
Collections-Traits
CollectionsTests
Compatibility
CompilerTests
CompressionTests
Deprecated14
EmergencyEvaluator
EventModel
FileSystem-AnsiStreams
FileSystem-Core
FileSystem-Disk
FileSystem-Memory
FileSystem-Tests-AnsiStreams
FileSystem-Tests-Core
FileSystem-Tests-Disk
FileSystem-Tests-Memory
FileSystem-Zip
FixUnderscores
FreeType
FreeTypeTests
Gofer-Tests
Graphics-External
Graphics-Files
Graphics-Fonts
Graphics-Resources
Graphics-Support
Graphics-Tests
Graphics-Text
HelpSystem-Core
HelpSystem-Tests
HostMenus
KernelTests
NECompletion
NOCompletion
MenuRegistration
MonticelloConfigurations
MonticelloGUI
MonticelloMocks
Morphic
MorphicTests
Multilingual-Tests
Network-Mail
Network-RFC822
Network-RemoteDirectory
NetworkTests
NonInteractiveTranscript
Polymorph-EventEnhancements
Polymorph-Geometry
Polymorph-TaskbarIcons
Polymorph-Tools-Diff
Polymorph-Widgets
RecentSubmissions
Regex-Core
Regex-Help
Regex-Tests-Core
Ring-Tests-Containers
Ring-Tests-Kernel
SUnit-Core
SUnit-Help
SUnit-Tests
SUnit-UI
ScriptLoader14
Settings-Compiler
Settings-Display
Settings-FreeType
Settings-Graphics
Settings-Kernel
Settings-Monticello
Settings-Network
Settings-Polymorph
Settings-System
Settings-Tools
Shout
ShoutTests
StartupPreferences
System-Applications
System-Download
System-FilePackage
System-Hashing
System-History
System-Installers
System-Serial Port
System-Settings
System-Sound
System-Text
System-Tools
Tests
Tools
ToolsTest
TrueType
UI-Basic
Zinc-Tests' lines.! !

!PharoKernelExporter methodsFor: 'loading' stamp: 'MarianoMartinezPeck 4/28/2012 12:26'!
loadFuel
	self log: 'Loading and installing Fuel from repository'.
	self loadPackagesNamed:  #( 'Fuel' 'FuelMetalevel' 'FuelPackageLoader') fromRepositoryNamed: 'http://ss3.gemstone.com/ss/Fuel'.
	self log: 'Finished'.
	
	! !

!PharoKernelExporter methodsFor: 'serialization' stamp: 'MarianoMartinezPeck 4/28/2012 12:24'!
serialize: anObject toFileNamed: aFileName
	FLSerializer serialize: anObject toFileNamed: aFileName.! !

!PharoKernelExporter methodsFor: 'serialization' stamp: 'MarianoMartinezPeck 4/28/2012 12:26'!
serializeClassVariablesAndFonts
	self log: 'Serializing class variables and fonts'.
	self serialize: (TextStyle named: 'Bitmap DejaVu Sans') toFileNamed: 'dejavu.fuel'.
	self serialize: (Unicode classPool at: #DecimalProperty) toFileNamed: 'decimalProperty.fuel'.
	self serialize: (Unicode classPool at: #GeneralCategory) toFileNamed: 'generalCategory.fuel'.
	self serialize: (UCSTable classPool at: #GB2312Table) toFileNamed: 'gb2312Table.fuel'.
	self serialize: (UCSTable classPool at: #JISX0208Table) toFileNamed: '#jisX0208Table.fuel'.
	self serialize: (UCSTable classPool at: #KSX1001Table) toFileNamed: '#ksx1001Table.fuel'.
	self log: 'Finished'.! !

PharoKernel subclass: #PharoKernelImporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoKernel'!

!PharoKernelImporter class methodsFor: 'instance-creation' stamp: 'MarianoMartinezPeck 4/28/2012 19:37'!
importCore
	self new importCore! !

!PharoKernelImporter methodsFor: 'private' stamp: 'MarianoMartinezPeck 4/28/2012 19:45'!
fixUndeclaredClasses
	
	#(TextDiffBuilder RecentMessageList CodeHolder PNGReadWriter FilePackage MCCodeTool MailSender
	  MailMessage PSMCPatchOperationWrapper ServerDirectory MailAddressParser JPEGReadWriter SoundService
	  GIFReadWriter ChangeList TTCFont FileContentsBrowser ChangeSorter TTFontReader Morph 
	  SARInstaller ZnHTTPSocketFacade ) 
		do: [:global | 
			Object subclass: global
			 	instanceVariableNames: ''
			 	classVariableNames: ''
			 	poolDictionaries: ''
			 	category: 'UNDECLARED'].! !

!PharoKernelImporter methodsFor: 'error' stamp: 'MarianoMartinezPeck 4/28/2012 20:01'!
handleError: error 
	| rep |
	"FLSerializer serialize: thisContext toFileNamed: 'PharoDebug.fuel'."
	rep := FileStream forceNewFileNamed: 'PharoDebug.log'.
	rep nextPutAll: 'Error:'; cr.
	rep nextPutAll: error asString; cr.
	rep nextPutAll: thisContext stack size asString; cr.
	" rep nextPutAll: ((thisContext stack copy at: 12) tempsAndValues ) asString; cr."
	thisContext stack copy withIndexDo: [:stck :i |
	[rep nextPutAll: i asString; space; nextPutAll: stck asString; cr] ifError: [:er | rep nextPutAll: er asString; cr].
	[rep tab; nextPutAll: stck tempsAndValues asString; cr ] ifError: [rep tab; nextPutAll: 'tempsAndValues error...'; cr]].
	rep close. 
	Smalltalk quitPrimitive
! !

!PharoKernelImporter methodsFor: 'importing' stamp: 'MarianoMartinezPeck 4/28/2012 20:05'!
importCore
	| timeToLoad |
	[
	self loadFuel.
	self fixUndeclaredClasses.
	timeToLoad := [self loadGofer.
	self loadRing.
	self loadPharoCore.] timeToRun.
	self log: 'PharoCore loaded in: ', timeToLoad asString, ' miliseconds'.
	]  ifError: [:e | self handleError: e ]
  ! !

!PharoKernelImporter methodsFor: 'private' stamp: 'MarianoMartinezPeck 4/28/2012 19:48'!
importPackageNamed: aFileName initilizingClasses: shouldInitializeClasses	

	FLPackage initializersEnabled: shouldInitializeClasses.
	FileStream readOnlyFileNamed: aFileName do: [:aStream | 
  		aStream binary.
  		FLPackageLoader new loadFrom: aStream contents readStream].! !

!PharoKernelImporter methodsFor: 'loading' stamp: 'MarianoMartinezPeck 4/28/2012 19:49'!
initializeGofer
	#(InternetConfiguration NetNameResolver Socket Base64MimeConverter 
MIMEType UUIDGenerator URI HTTPSocket PackageInfo PackageServices 
FileServices SystemAnnouncer MCCacheRepository MCDirtyPackageInfo 
MCEmptyPackageInfo MCMethodDefinition MCMockASubclass MCMockClassA 
MCMockPackageInfo MCPackageManager MCVersionReader MCWorkingCopy 
ZnByteEncoder ZnConstants ZnMimeType ZnNetworkingUtils ZnServer 
ZnSingleThreadedServer) do: [:c | (Smalltalk globals at: c) initialize ].! !

!PharoKernelImporter methodsFor: 'loading' stamp: 'MarianoMartinezPeck 4/28/2012 19:43'!
loadFuel
	self log: 'Loading Fuel'.
	"we assume the Fuel .st files were already downloaded during the export."
	self installPackagesNamed: #( 'Fuel' 'FuelMetalevel' 'FuelPackageLoader').
	self log: 'Finished'.! !

!PharoKernelImporter methodsFor: 'loading' stamp: 'MarianoMartinezPeck 4/28/2012 19:50'!
loadGofer
	self log: 'Loading Gofer'.
	self importPackageNamed: 'gofer.fuel' initilizingClasses: false.
	self initializeGofer.
	self log: 'Finished'.! !

!PharoKernelImporter methodsFor: 'loading' stamp: 'MarianoMartinezPeck 4/28/2012 21:37'!
loadPharoCore
	self log: 'Loading PharoCore'.
	self registerNeededGlobalVariables.
	self importPackageNamed: 'pharo-core.fuel' initilizingClasses: false.
	self log: 'Finished'.
	! !

!PharoKernelImporter methodsFor: 'loading' stamp: 'MarianoMartinezPeck 4/28/2012 19:55'!
loadRing
	self log: 'Loading Ring'.
	self importPackageNamed: 'ring.fuel' initilizingClasses: true.
	self log: 'Finished'.
	! !

!PharoKernelImporter methodsFor: 'loading' stamp: 'MarianoMartinezPeck 4/28/2012 21:38'!
registerNeededGlobalVariables
	"This is needed because during the serialization they were serialized. Therefore, during materialization, if they are not present in Smalltalk globals, there will be an error"
	#(World ActiveEvent ActiveWorld ActiveHand) do: [:className | 
  Smalltalk globals at: className put: nil].
! !
